<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: bmp_rd_wr.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>bmp_rd_wr.h File Reference</h1><hr/><a name="_details"></a><h2>Introduction</h2>
<p>Utility APIs to read and write .BMP files </p>

<p>Definition in file <a class="el" href="bmp__rd__wr_8h_source.html">bmp_rd_wr.h</a>.</p>

<p><a href="bmp__rd__wr_8h_source.html">Go to the source code of this file.</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">vx_status&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp__rd__wr_8h.html#a9fd09ad0e348951c4af9dbb4c852cfd5">bmp_file_read</a> (char *filename, vx_bool convert_to_gray_scale, uint32_t *width, uint32_t *height, uint32_t *stride, vx_df_image *df, void **data_ptr, void **bmp_file_context)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Read data from BMP file.  <a href="#a9fd09ad0e348951c4af9dbb4c852cfd5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp__rd__wr_8h.html#a2a612b23e595a4ac11ba207c88c03be6">bmp_file_read_release</a> (void *bmp_file_context)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Free memory allocated during bmp_file_read.  <a href="#a2a612b23e595a4ac11ba207c88c03be6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int32_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="bmp__rd__wr_8h.html#a34dec5bef3b7ecc629d59645b1c6306e">bmp_file_write</a> (char *filename, uint32_t width, uint32_t height, uint32_t stride, vx_df_image df, void *data_ptr)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Write data into BMP file.  <a href="#a34dec5bef3b7ecc629d59645b1c6306e"></a><br/></td></tr>
</table>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="a9fd09ad0e348951c4af9dbb4c852cfd5"></a><!-- doxytag: member="bmp_rd_wr.h::bmp_file_read" ref="a9fd09ad0e348951c4af9dbb4c852cfd5" args="(char *filename, vx_bool convert_to_gray_scale, uint32_t *width, uint32_t *height, uint32_t *stride, vx_df_image *df, void **data_ptr, void **bmp_file_context)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">vx_status bmp_file_read </td>
          <td>(</td>
          <td class="paramtype">char *&nbsp;</td>
          <td class="paramname"> <em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vx_bool&nbsp;</td>
          <td class="paramname"> <em>convert_to_gray_scale</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&nbsp;</td>
          <td class="paramname"> <em>width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&nbsp;</td>
          <td class="paramname"> <em>height</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t *&nbsp;</td>
          <td class="paramname"> <em>stride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vx_df_image *&nbsp;</td>
          <td class="paramname"> <em>df</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void **&nbsp;</td>
          <td class="paramname"> <em>data_ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void **&nbsp;</td>
          <td class="paramname"> <em>bmp_file_context</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Read data from BMP file. </p>
<p>'bmp_file_context' holds the BMP file context including internally allcoated memory/resource information</p>
<p>When data from 'data_ptr' is copied by the user application, the 'bmp_file_context' MUST be released via <a class="el" href="bmp__rd__wr_8h.html#a2a612b23e595a4ac11ba207c88c03be6" title="Free memory allocated during bmp_file_read.">bmp_file_read_release()</a> in order to free any memory/resources allocated during <a class="el" href="bmp__rd__wr_8h.html#a9fd09ad0e348951c4af9dbb4c852cfd5" title="Read data from BMP file.">bmp_file_read()</a></p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>filename</em>&nbsp;</td><td>[in] BMP file name. MUST have .bmp or .BMP extension </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>convert_to_gray_scale</em>&nbsp;</td><td>[in] TRUE: convert to gray scale after reading, FALSE: keep RGB format after reading </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>df</em>&nbsp;</td><td>[out] Data format of BMP file, will be VX_DF_IMAGE_U8 or VX_DF_IMAGE_RGB </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>width</em>&nbsp;</td><td>[out] Width of image in pixels </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>height</em>&nbsp;</td><td>[out] Height of image in lines </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>stride</em>&nbsp;</td><td>[out] Horizontal stride of image in units of bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>data_ptr</em>&nbsp;</td><td>[out] Data buffer into which the BMP dara is read. Allocated by this API internally </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>bmp_file_context</em>&nbsp;</td><td>[out] BMP file context for this file</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>VX_SUCCESS if file could be opened, parsed and read successfully </dd></dl>

</div>
</div>
<a class="anchor" id="a2a612b23e595a4ac11ba207c88c03be6"></a><!-- doxytag: member="bmp_rd_wr.h::bmp_file_read_release" ref="a2a612b23e595a4ac11ba207c88c03be6" args="(void *bmp_file_context)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void bmp_file_read_release </td>
          <td>(</td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>bmp_file_context</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Free memory allocated during bmp_file_read. </p>
<p>MUST be called by application after its done using the pixel data returned <a class="el" href="bmp__rd__wr_8h.html#a9fd09ad0e348951c4af9dbb4c852cfd5" title="Read data from BMP file.">bmp_file_read()</a> The 'bmp_file_context' returned by the function <a class="el" href="bmp__rd__wr_8h.html#a9fd09ad0e348951c4af9dbb4c852cfd5" title="Read data from BMP file.">bmp_file_read()</a> must be used as input to this API.</p>
<p>'data_ptr' returned by <a class="el" href="bmp__rd__wr_8h.html#a9fd09ad0e348951c4af9dbb4c852cfd5" title="Read data from BMP file.">bmp_file_read()</a> MUST not be used after <a class="el" href="bmp__rd__wr_8h.html#a2a612b23e595a4ac11ba207c88c03be6" title="Free memory allocated during bmp_file_read.">bmp_file_read_release()</a> is called.</p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>bmp_file_context</em>&nbsp;</td><td>[in] BMP file context returned during <a class="el" href="bmp__rd__wr_8h.html#a9fd09ad0e348951c4af9dbb4c852cfd5" title="Read data from BMP file.">bmp_file_read()</a> </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a34dec5bef3b7ecc629d59645b1c6306e"></a><!-- doxytag: member="bmp_rd_wr.h::bmp_file_write" ref="a34dec5bef3b7ecc629d59645b1c6306e" args="(char *filename, uint32_t width, uint32_t height, uint32_t stride, vx_df_image df, void *data_ptr)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int32_t bmp_file_write </td>
          <td>(</td>
          <td class="paramtype">char *&nbsp;</td>
          <td class="paramname"> <em>filename</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>height</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&nbsp;</td>
          <td class="paramname"> <em>stride</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vx_df_image&nbsp;</td>
          <td class="paramname"> <em>df</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>data_ptr</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Write data into BMP file. </p>
<dl><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>filename</em>&nbsp;</td><td>[in] BMP file name. MUST have .bmp or .BMP extension </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>width</em>&nbsp;</td><td>[in] Width of image in pixels </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>height</em>&nbsp;</td><td>[in] Height of image in lines </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>stride</em>&nbsp;</td><td>[in] Stride of image in units of bytes </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>df</em>&nbsp;</td><td>[in] Data format of data written into BMP file, MUST be VX_DF_IMAGE_U8 or VX_DF_IMAGE_RGB </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>data_ptr</em>&nbsp;</td><td>[in] Data buffer from where the data is to written to BMP file</td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>VX_SUCCESS if file could be opened, and written successfully </dd></dl>

</div>
</div>
</div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
